
QGIS Application - Bug report #17606

QGIS Server 2.14.19 WFS GetFeature Server Error

2017-12-02 09:44 PM - Uroš Preložnik

Status: Closed

Priority: High

Assignee:

Category: QGIS Server

Affected QGIS version:2.14.19 Regression?: No

Operating System: Windows, Ubuntu Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:Yes Copied to github as #: 25503

Description

This is 2.14 issue tested on 2.14.19 and 2.14.20 on Windows and Linux servers.

Simple POST call to QGIS server and project with this data:

<wfs:GetFeature xmlns:wfs="http://www.opengis.net/wfs" service="WFS" version="1.0.0" maxFeatures="1"

xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wfs

http://schemas.opengis.net/wfs/1.0.0/WFS-transaction.xsd">

    <wfs:Query typeName="lines">

        <ogc:Filter xmlns:ogc="http://www.opengis.net/ogc">

            <ogc:FeatureId fid="lines.1"/>

        </ogc:Filter>

    </wfs:Query>

</wfs:GetFeature>

Generates server error. No errors in QGIS log (very frustrating) and this in Apache error log:

[Sat Dec 02 21:26:38.800759 2017] [core:error] [pid 3752] [client 127.0.0.1:42244] End of script output before headers:

qgis_mapserv.fcgi

QGIS log data for that request:

[4209][21:26:38] ******************** New request ***************

[4209][21:26:38] REMOTE_ADDR: 127.0.0.1

[4209][21:26:38] HTTP_USER_AGENT: GuzzleHttp/6.2.1 curl/7.47.0 PHP/7.0.22-0ubuntu0.16.04.1

[4209][21:26:38] QgsPostRequestHandler::parseInput

[4209][21:26:38] QgsHttpRequestHandler::readPostBody

[4209][21:26:38] length is: 411

[4209][21:26:38] <wfs:GetFeature xmlns:wfs="http://www.opengis.net/wfs" service="WFS" version="1.0.0" maxFeatures="1"

xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wfs

http://schemas.opengis.net/wfs/1.0.0/WFS-transaction.xsd"><wfs:Query typeName="lines"><ogc:Filter

xmlns:ogc="http://www.opengis.net/ogc"><ogc:FeatureId fid="lines.9"/></ogc:Filter></wfs:Query></wfs:GetFeature>

[4209][21:26:38] inserting pair MAP // /home/uros/GIS/projects/eu_demo.qgs into the parameter map

[4209][21:26:38] query string is: map=%2Fhome%2Furos%2FGIS%2Fprojects%2Feu_demo.qgs

[4209][21:26:38] inserting pair MAP // /home/uros/GIS/projects/eu_demo.qgs into the parameter map

[4209][21:26:38] MAP:/home/uros/GIS/projects/eu_demo.qgs

[4209][21:26:38] REQUEST:GetFeature

[4209][21:26:38] REQUEST_BODY:<wfs:GetFeature xmlns:wfs="http://www.opengis.net/wfs" service="WFS" version="1.0.0"

maxFeatures="1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wfs

http://schemas.opengis.net/wfs/1.0.0/WFS-transaction.xsd"><wfs:Query typeName="lines"><ogc:Filter

xmlns:ogc="http://www.opengis.net/ogc"><ogc:FeatureId fid="lines.9"/></ogc:Filter></wfs:Query></wfs:GetFeature>

[4209][21:26:38] SERVICE:WFS

[4209][21:26:38] VERSION:1.0.0
[4209][21:26:38] Info format is:

[4209][21:26:38] Layer 'lines20170406115756570' url: '' configFile: /home/uros/GIS/projects/eu_demo.qgs found in layer cache

[4209][21:26:38] Sending HTTP response

[4209][21:26:38] Sending HTTP response

Important note is that same request, with exactly same data works in 2.14.16 or earlier. So something is broken in between

this LTR updates.

History

#1 - 2017-12-02 09:46 PM - Uroš Preložnik

Also noting that this problem affects Line geometry layer from postgis table. Points and Polygons are working.

And in the project properties under OWS server I'm using setting use layer ids as names. Although all calls to WFS with typename (layer) are with layer

name not layer id.

#2 - 2017-12-17 11:26 AM - Uroš Preložnik

Tested today on 2.14.21, same problem :(

#3 - 2018-02-22 09:41 AM - René-Luc ReLuc

I have fixed an issue in 2.14 about MultiLineString in GML commit:d8ca6367ff7e65bb39e0c09ee9b3d2b479a689f3 that has been fixed a while in 2.18 but

not backported.

I also have fixed an issue in 2.14, 2.18 and 3.0 about null geometry in GML :

    -  2.14 commit:decb722ee6ae38f16a777a88948f3c62263fae34

    -  2.18 commit:d0fb7fec968987d3dd5433c7c1c4981f53876d5a

    -  3.0 commit:158207301146ee6e1f7828b48d58fe674287e0c7

Can you build and test ?

#4 - 2018-02-22 09:53 AM - Uroš Preložnik

René-Luc ReLuc wrote:

I have fixed an issue in 2.14 about MultiLineString in GML commit:d8ca6367ff7e65bb39e0c09ee9b3d2b479a689f3 that has been fixed a while in

2.18 but not backported.

I also have fixed an issue in 2.14, 2.18 and 3.0 about null geometry in GML :    -  2.14 commit:decb722ee6ae38f16a777a88948f3c62263fae34

    -  2.18 commit:d0fb7fec968987d3dd5433c7c1c4981f53876d5a

    -  3.0 commit:158207301146ee6e1f7828b48d58fe674287e0c7

Can you build and test ?

Ok, great. I can test but don't have environment setup for building QGIS and have never done it. Can I wait for nightly build for ltr-dev and test that? When

will it be, tomorrow?

#5 - 2018-11-07 09:20 PM - Giovanni Manghi
- Status changed from Open to Feedback

Please try on QGIS 3.4.1, if the issue is still valid change the affected version, thanks.

#6 - 2018-11-08 11:32 AM - Uroš Preložnik

Giovanni Manghi wrote:

Please try on QGIS 3.4.1, if the issue is still valid change the affected version, thanks.

There is no issue with this on 3.4 and it was only on 2.14 from start. It could be related to MultiLine String, but now I don't use 2.14 anymore to test it.

Probably this was fixed after ReneLuc commits above.

#7 - 2018-11-08 11:51 AM - Giovanni Manghi

- Resolution set to fixed/implemented

- Status changed from Feedback to Closed
